from espace import *
from random import uniform

sparks = list()
smokes = list()
fires = list()
explosions = list()
spark = 0
smoke = 0
fire = 0
explosion = 0

# Sources (channels) for playing sounds
soundSources = list()
soundSource = 0

explosionSound = 0

def init():
  global spark, smoke, fire, explosion, explosionSound

  spark = Shader.acquireHandle("textures/effects/spark")
  smoke = Shader.acquireHandle("textures/effects/smoke")
  fire = Shader.acquireHandle("textures/effects/fire")
  explosion = Shader.acquireHandle("textures/effects/explosion")

  explosionSound = Sound.acquire("sounds/rocket_hit.wav")

  global soundSources, soundSource

  for a in range(1, 8):
    source = SoundSource()
    source.setReferenceDistance(1000)
    soundSources.append(source)

def addSparks(position, direction):
  global sparks

  for i in range(1, 10):
    sparks.append([position,
                   direction + Vector3(uniform(-1, 1),
                                       uniform(-1, 1),
                                       uniform(-1, 1)) * 100,
                   uniform(0.15, 0.5)])

def addSmoke(position):
  global smokes

  smokes.append([position, 1, uniform(0, 6.28)])

def addFire(position):
  global fires

  fires.append([position, 1, uniform(0, 6.28)])

def addExplosion(position):
  global explosions

  for i in range(1, 10):
    explosions.append([position + Vector3(uniform(-1, 1),
                                          uniform(-1, 1),
                                          uniform(-1, 1)) * 100,
                      1,
                      uniform(0, 6.28),
                      i == 1])

  global soundSource, soundSources

  # Play sound
  source = soundSources[soundSource]
  source.stop()
  source.setPosition(position)
  source.setGain(1.0)
  source.play(explosionSound)

  soundSource += 1
  if soundSource == len(soundSources):
    soundSource = 0

def think(deltaTime):
  global sparks

  for a in sparks:
    a[2] -= deltaTime

    if a[2] < 0:
      sparks.remove(a)
      continue

    a[0] = a[0] + a[1] * deltaTime

  global smokes

  for a in smokes:
    a[1] -= deltaTime

    if a[1] < 0:
      smokes.remove(a)

  global fires

  for a in fires:
    a[1] -= deltaTime * 10

    if a[1] < 0:
      fires.remove(a)

  global explosions

  for a in explosions:
    a[1] -= deltaTime * uniform(0.1, 2)

    if a[1] < 0:
      explosions.remove(a)
    
def addToScene():
  global sparks, spark

  for a in sparks:
    entity = RefEntity()

    entity.type = RefEntity.Sprite
    entity.renderfx = 0
    entity.origin = a[0]
    entity.customShader = spark
    entity.radius = 2

    Renderer.appendRefEntity(entity)

  global smokes, smoke

  for a in smokes:
    entity = RefEntity()

    entity.type = RefEntity.Sprite
    entity.renderfx = 0
    entity.origin = a[0]
    entity.customShader = smoke
    entity.radius = 20 + (1 - a[1]) * 20
    entity.color = Color(a[1], a[1], a[1])
    entity.rotation = a[2]

    Renderer.appendRefEntity(entity)

  global fires, fire

  for a in fires:
    entity = RefEntity()

    entity.type = RefEntity.Sprite
    entity.renderfx = 0
    entity.origin = a[0]
    entity.customShader = fire
    entity.radius = 20 * a[1]
    entity.color = Color(a[1], a[1], a[1])
    entity.rotation = a[2]

    Renderer.appendRefEntity(entity)

  global explosions, explosion

  for a in explosions:
    entity = RefEntity()

    entity.type = RefEntity.Sprite
    entity.renderfx = 0
    entity.origin = a[0]
    entity.customShader = explosion
    entity.radius = 200
    entity.rotation = a[2]
    entity.time = a[1] * 100

    Renderer.appendRefEntity(entity)
    if a[3]:
      Renderer.addLight(a[0], 300, Color(1.0 * a[1], 0.8 * a[1], 0.6 * a[1]))
