# Namespace for entities, including projectiles, powerups and players.

entities = list()

def append(entity):
  global entities

  entities.append(entity)

def remove(entity):
  global entities

  entities.remove(entity)

def clear():
  global entities

  entities = list()

def think(deltaTime):
  global entities

  for e in entities:
    if e.spawntime > 0:
      e.spawntime -= deltaTime
      if e.spawntime < 0:
        e.spawntime = 0
      continue

    e.think(deltaTime)

def checkHits(player):
  global entities

  for e in entities:
    if e.spawntime <= 0:
      if (e.origin - player.rd.origin).magnitude() < e.radius + player.radius:
        e.hit(player)

def addToScene():
  global entities

  for e in entities:
    if e.spawntime == 0:
      e.addToScene()

