from espace import *

def fact(n):
  if n == 0:
    return 1

  return n * fact(n - 1)

def choose(n, m):
  return fact(n) / (fact(n - m) * fact(m))

def B(i, n, t):
  return choose(n, i) * pow(t, i) * pow(1 - t, n - i)

class Path:
  def __init__(self, filename):
    input = Preprocessor(filename)
    self.points = list()

    while True:
      token = input.nextToken()

      if not token:
        break

      if token == "\n":
        continue

      if token != "(":
        print "Parse error at \"%s\" in \"%s\"" % (token, filename)
        break

      x = float(input.nextToken())
      y = float(input.nextToken())
      z = float(input.nextToken())

      self.points.append((x, y, z))

      if input.nextToken() != ")":
        print "Parse error at \"%s\" in \"%s\"" % (token, filename)
        break

  def point(self, t):
    point = (0, 0, 0)
    n = len(self.points)

    for i in range(0, n):
      f = B(i, n - 1, t)
      point = (point[0] + self.points[i][0] * f,
               point[1] + self.points[i][1] * f,
               point[2] + self.points[i][2] * f)

    return Vector3(point[0], point[1], point[2])
