#ifndef ZIP_H_
#define ZIP_H_

#include <map>
#include <vector>

#include <zlib.h>

#include <espace/plugins.h>

class ZIP : public ArchivePlugin
{
public:

  uint32_t id();
  bool canHandle(File& archive);
  void scan(File& archive, const String& archiveName, std::vector<FileEntry>& entries);
  void readEntry(File& archive, const FileEntry& entry, File& ret);

  int  open(const FileEntry& entry);
  void read(int handle, void* buffer, uint count);
  void seek(int handle, uint position);
  void close(int handle);

protected:

  class Handle
  {
  public:

    File*    archive;
    uint     start;
    uint     offset;
    uint     compMethod;
    uint     compSize;
    uint     compOffset;
    z_stream zStream;
    char*    buffer;
    uint     bufferSize;
  };

  static std::map<int, Handle>   handles;
  static int                     nextHandle;
  static std::map<String, File*> fileHandles;
};

#endif // !ZIP_H_

// vim: ts=2 sw=2 et
